.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
.xmm

Floor4	PROTO: REAL4
Floor4a	PROTO: REAL4
Floor4b	PROTO: REAL4
Floor4c	PROTO: REAL4
Floor8	PROTO: REAL8
MbCeil	PROTO: REAL4

; Macro usage:
; print str$(FLOOR(MySingle4))
; print str$(FLOOR(MySingle8))

FLOOR MACRO arg
  if SIZEOF arg eq 8
	invoke Floor8, arg
  else
	invoke Floor4, arg
  endif
  EXITM <eax>
ENDM

CEIL MACRO arg
  invoke MbCeil, arg
  EXITM <eax>
ENDM

.code
MySingle1	REAL4 12.34567890123456
MySingle2	REAL4 -12.34567890123456
MySingle3	REAL4 0.99999999
MySingle4	REAL4 -1.000000001
MySingle5	REAL4 -1.5
MySingle6	REAL4 +1.5

MyDouble1	REAL8 12.34567890123456
MyDouble2	REAL8 -12.34567890123456
MyDouble3	REAL8 0.99999999
MyDouble4	REAL8 -1.000000001
MyDouble5	REAL8 -1.5
MyDouble6	REAL8 +1.5

sngMinusOneHalf	REAL4 -0.5

start:
	print "Floor timings:", 13, 10
	
	print chr$(13, 10, "MySingle1	REAL4 12.34567890123456", 9, "floor= ")
	print str$(FLOOR(MySingle1))
	print chr$(13, 10, "MyDouble1	REAL8 12.34567890123456", 9, "floor= ")
	print str$(FLOOR(MyDouble1))

	print chr$(13, 10, "MySingle2	REAL4 -12.345678901234", 9, "floor= ")
	print str$(FLOOR(MySingle2))
	print chr$(13, 10, "MyDouble2	REAL8 -12.345678901234", 9, "floor= ")
	print str$(FLOOR(MyDouble2))

	print chr$(13, 10, "MySingle3	REAL4 0.99999999", 9, "floor= ")
	print str$(FLOOR(MySingle3)), 9, "(sic!)"
	print chr$(13, 10, "MyDouble3	REAL8 0.99999999", 9, "floor= ")
	print str$(FLOOR(MyDouble3)), 13, 10, 10

	LoopCount	= 1000000
	invoke Sleep, 500
	REPEAT 4
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke Floor8, MyDouble1
		invoke Floor8, MyDouble2
		invoke Floor8, MyDouble3
		invoke Floor8, MyDouble4
		invoke Floor8, MyDouble5
	counter_end
	print str$(eax), 9, "cycles for Floor8", 13,10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke Floor4, MySingle1
		invoke Floor4, MySingle2
		invoke Floor4, MySingle3
		invoke Floor4, MySingle4
		invoke Floor4, MySingle5
	counter_end
	print str$(eax), 9, "cycles for Floor4", 13,10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke Floor4a, MySingle1
		invoke Floor4a, MySingle2
		invoke Floor4a, MySingle3
		invoke Floor4a, MySingle4
		invoke Floor4a, MySingle5
	counter_end
	print str$(eax), 9, "cycles for Floor4a", 13,10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke Floor4b, MySingle1
		invoke Floor4b, MySingle2
		invoke Floor4b, MySingle3
		invoke Floor4b, MySingle4
		invoke Floor4b, MySingle5
	counter_end
	print str$(eax), 9, "cycles for Floor4b", 13,10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		invoke Floor4c, MySingle1
		invoke Floor4c, MySingle2
		invoke Floor4c, MySingle3
		invoke Floor4c, MySingle4
		invoke Floor4c, MySingle5
	counter_end
	print str$(eax), 9, "cycles for Floor4c", 13,10, 10
	ENDM
	getkey
	exit

OPTION EPILOGUE:none
OPTION PROLOGUE:none
Floor8     proc float_value:REAL8	; credits to [url=http://www.masm32.com/board/index.php?topic=9515.msg78719#msg78719]chrisw[/url]
  cvttsd2si eax, REAL8 ptr [esp+4]
  mov ecx, dword ptr [esp+8]
  shr ecx, 31
  sub eax, ecx
  ; cvtsi2ss xmm0, ecx		; if needed for further processing
  ret 8
Floor8    endp

Floor4     proc float_value:REAL4	; credits to [url=http://www.masm32.com/board/index.php?topic=9515.msg78719#msg78719]chrisw[/url]
  cvttss2si eax, REAL4 ptr [esp+4]
  mov ecx, dword ptr [esp+4]
  if 0
;	sal ecx, 1
;	sbb eax, 0
  else
	shr ecx, 31
	sub eax, ecx
  endif
  ; cvtsi2ss xmm0, ecx		; if needed for further processing
  ret 4
Floor4    endp

Floor4a     proc float_value:REAL4	; credits to [url=http://www.masm32.com/board/index.php?topic=9515.msg78719#msg78719]chrisw[/url]
  cvttss2si eax, REAL4 ptr [esp+4]
  mov ecx, dword ptr [esp+4]
  if 1
	sal ecx, 1
	sbb eax, 0
  else
;	shr ecx, 31
;	sub eax, ecx
  endif
  ; cvtsi2ss xmm0, ecx		; if needed for further processing
  ret 4
Floor4a    endp

Floor4b     proc float_value:REAL4	; credits to [url=http://www.masm32.com/board/index.php?topic=9515.msg78719#msg78719]chrisw[/url]
  cvttss2si eax, REAL4 ptr [esp+4]
  mov ecx, eax 			; same as dword ptr [esp+4] but shorter
  if 0
;	sal ecx, 1
;	sbb eax, 0
  else
	shr ecx, 31
	sub eax, ecx
  endif
  ; cvtsi2ss xmm0, ecx		; if needed for further processing, 5 cycles more
  ret 4
Floor4b    endp

Floor4c     proc float_value:REAL4	; credits to [url=http://www.masm32.com/board/index.php?topic=9515.msg78719#msg78719]chrisw[/url]
  cvttss2si eax, REAL4 ptr [esp+4]
  mov ecx, eax 		; same as dword ptr [esp+4] but shorter
  if 1
	sal ecx, 1
	sbb eax, 0
  else
;	shr ecx, 31
;	sub eax, ecx
  endif
  ; cvtsi2ss xmm0, ecx		; if needed for further processing
  ret 4
Floor4c    endp

OPTION EPILOGUE:EpilogueDef
OPTION PROLOGUE:PrologueDef

MbCeil proc float_value:REAL4	; credits to Greg
    movss xmm0, float_value
    addss xmm0, xmm0
    movss xmm1, sngMinusOneHalf
    subss xmm1, xmm0
    cvtss2si eax, xmm1
    sar eax, 1
    neg eax
    ; cvtsi2ss xmm0, eax
    ret
MbCeil endp

end start
OxPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_WAIT	0	; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
